# NOTE: Derived from blib/lib/Net/UKDomain/Nominet/Automaton.pm.
# Changes made here will be lost when autosplit is run again.
# See AutoSplit.pm.
package Net::UKDomain::Nominet::Automaton;

#line 570 "blib/lib/Net/UKDomain/Nominet/Automaton.pm (autosplit into blib/lib/auto/Net/UKDomain/Nominet/Automaton/is_mandatory.al)"
sub is_mandatory {
	# http://www.nominet.org.uk/registrars/systems/data/fields/
	
	my $idetails = shift;
	my $operation = uc($idetails->{'operation'});
	my @mandatory;

	# Operation is always mandatory
	push(@mandatory,'operation');

	my $key_operations = 'REQUEST|DELETE|RENEW';
	# Domain (key) is always mandatory for the above operations
	if (($operation =~ m/^$key_operations$/i)) {
			push(@mandatory,'key');
	}

	if ($operation eq 'REQUEST') {
		# If account-id is not supplied, the below fields are also mandatory
		if (!$idetails->{'account-id'}) {
			push(@mandatory,('account-name','addr','country','a1-name','a1-email'));
		}
		# If opt-out is supplied, type is also mandatory
		if ($idetails->{'opt-out'}) { push(@mandatory,'type'); }
	}
	
	# registrar-tag is mandatory for release requests only
	if ($operation eq 'RELEASE') { push(@mandatory,'registrar-tag'); }
	
	# case-id is mandatory for the handshake
	if ($operation eq 'RECEIVE') { push(@mandatory,'case-id'); }

	# If a2-name is supplied, a2-email is also mandatory
	if ($idetails->{'a2-name'}) { push(@mandatory,'a2-email'); }

	# If a3-name is supplied, a3-email is also mandatory
	if ($idetails->{'a3-name'}) { push(@mandatory,'a3-email'); }

	# If b1-name is supplied, b1-email is also mandatory
	if ($idetails->{'b1-name'}) { push(@mandatory,'b1-email'); }

	# If b2-name is supplied, b2-email is also mandatory
	if ($idetails->{'b2-name'}) { push(@mandatory,'b2-email'); }
	
	# If b3-name is supplied, b3-email is also mandatory
	if ($idetails->{'b3-name'}) { push(@mandatory,'b3-email'); }
	
	my $need_postcode = "(GB|JE|GG|IM)"; # See: http://www.iso.org/iso/iso3166_en_code_lists.txt
	# If country code is in the list, postcode is also mandatory
	if ($idetails->{'country'} =~ /^$need_postcode$/) { push(@mandatory,'postcode'); }

	# If billing country code is in the list, postcode is also mandatory
	if ($idetails->{'b-country'} =~ /^$need_postcode$/) { push(@mandatory,'b-postcode'); }

	my $need_co_no = 'LTD|PLC|LLP|IP';
	# If domain is a company sld, company number (co-no) is also mandatory
	if (($idetails->{'type'} =~ /$need_co_no/i)) { push(@mandatory,'co-no'); }

	#my %mandatory_hash = ();
	#for (@mandatory) { $mandatory_hash{$_} = 1; }

	foreach $field (@mandatory) {
		if (!defined $idetails->{$field}) {
			$errstr = "Mandatory field '$field' is missing";
			return;
		}
		if (!$idetails->{$field}) {
			$errstr = "Mandatory field '$field' cannot be empty";
			return;
		}
	}
	return 1;
}

# end of Net::UKDomain::Nominet::Automaton::is_mandatory
1;
