# NOTE: Derived from blib/lib/Net/UKDomain/Nominet/Automaton.pm.
# Changes made here will be lost when autosplit is run again.
# See AutoSplit.pm.
package Net::UKDomain::Nominet::Automaton;

#line 951 "blib/lib/Net/UKDomain/Nominet/Automaton.pm (autosplit into blib/lib/auto/Net/UKDomain/Nominet/Automaton/valid_domain.al)"
sub valid_domain {
	# Checks domain length, whitespace, SLD, and invalid chars
	
	my $self = shift;
	my $domain = lc shift;
	
	if (!$domain) {
		$errstr = "Domain is required";
		return;
	}

	my $MAX_LENGTH = 63;

	if (length $domain > $MAX_LENGTH) {
		$errstr = "Domain name too long - max 63 characters";
		return;
	}
	if ($domain =~ m/\s/) {
		$errstr = "Domain cannot contain space character";
		return;
	}
	if ($domain !~ /$sldsi$/i) {
		$errstr = "Invalid domain name SLD";
		return;
	}
	if ($domain !~ /^[a-zA-Z0-9][.a-zA-Z0-9\-]*[a-zA-Z0-9]$sldsi$/i) {
		$errstr = "Domain contains invalid characters. Use only A-Z 0-9 and -";
		return;
	}
	return 1;
}

# end of Net::UKDomain::Nominet::Automaton::valid_domain
1;
